Loading...
Searching...
No Matches
Sip_accept

## Data Structures

struct | sip_accept_s
| Structure for Accept header field. More...

## Macros

#define | sip_accept(sip)
| Access a SIP Accept header structure sip_accept_t from sip_t.
#define | SIP_ACCEPT_INIT()
| Initializer for structure sip_accept_t.
#define | SIPTAG_ACCEPT(x)
| Tag list item for pointer to a Accept header structure sip_accept_t.
#define | SIPTAG_ACCEPT_REF(x)
| Tag list item for reference to a Accept header pointer.
#define | SIPTAG_ACCEPT_STR(s)
| Tag list item for string with Accept header value.
#define | SIPTAG_ACCEPT_STR_REF(x)
| Tag list item for reference to a Accept header string.

## Typedefs

typedef struct sip_accept_s | sip_accept_t
| @

## Functions

issize_t | sip_accept_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Accept header.
issize_t | sip_accept_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Accept header.
sip_accept_t * | sip_accept_init (sip_accept_t x[1])
| Initialize a structure sip_accept_t.
int | sip_is_accept (sip_header_t const *header)
| Test if header object is instance of sip_accept_t.
sip_accept_t * | sip_accept_dup (su_home_t *home, sip_accept_t const *hdr))
| Duplicate a list of Accept header header structures sip_accept_t.
sip_accept_t * | sip_accept_copy (su_home_t *home, sip_accept_t const *hdr))
| Copy a list of Accept header header structures sip_accept_t.
sip_accept_t * | sip_accept_make (su_home_t *home, char const *s))
| Make a Accept header structure sip_accept_t.
sip_accept_t * | sip_accept_format (su_home_t *home, char const *fmt,...)))
| Make a Accept header from formatting result.

## Variables

msg_hclass_t | sip_accept_class []
| Header class for Accept header.
tag_typedef_t | siptag_accept
| Tag for Accept header object.
tag_typedef_t | siptag_accept_str
| Tag for string with Accept header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ACCEPT_INIT

#define SIP_ACCEPT_INIT | ( |  | ) |

Initializer for structure sip_accept_t.

A static sip_accept_t structure for Accept header must be initialized with the SIP_ACCEPT_INIT() macro. For instance,

sip_accept_t sip_accept = SIP_ACCEPT_INIT;
sip_accept
#define sip_accept(sip)
Access a SIP Accept header structure sip_accept_t from sip_t.
Definition sip_protos.h:7033
SIP_ACCEPT_INIT
#define SIP_ACCEPT_INIT()
Initializer for structure sip_accept_t.
Definition sip_protos.h:7050
sip_accept_t
struct sip_accept_s sip_accept_t
@
Definition sip.h:139

## SIPTAG_ACCEPT

#define SIPTAG_ACCEPT | ( |  | x | ) |

Tag list item for pointer to a Accept header structure sip_accept_t.

The SIPTAG_ACCEPT() macro is used to include a tag item with a pointer to a sip_accept_t structure in a tag list.

Parameters

  x | pointer to a sip_accept_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_REF().

## SIPTAG_ACCEPT_STR

#define SIPTAG_ACCEPT_STR | ( |  | s | ) |

Tag list item for string with Accept header value.

The SIPTAG_ACCEPT_STR() macro is used to include a tag item with a string containing value of a sip_accept_t header in a tag list.

Parameters

  s | pointer to a string containing Accept header value, or NULL.

The string in SIPTAG_ACCEPT_STR() can be converted to a sip_accept_t header structure by giving the string s has second argument to function sip_accept_make().

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_STR_REF().

## Typedef Documentation

## sip_accept_t

typedef struct sip_accept_s sip_accept_t

@

The Accept request-header field can be used to specify certain media types which are acceptable for the response. Its syntax is defined in [H14.1, S10.6] as follows:

Accept = "Accept" HCOLON
[ accept-range *(COMMA accept-range) ]
accept-range = media-range *(SEMI accept-param)
media-range = ( "*" "/" "*"
/ ( m-type SLASH "*" )
/ ( m-type SLASH m-subtype )
) *( SEMI m-parameter )
accept-param = ("q" EQUAL qvalue) / generic-param
qvalue = ( "0" [ "." 0*3DIGIT ] )
/ ( "1" [ "." 0*3("0") ] )
generic-param = token [ EQUAL gen-value ]
gen-value = token / host / quoted-string
DIGIT
#define DIGIT

The parsed Accept header is stored in sip_accept_t structure.

The structure sip_accept_t contains representation of SIP Accept header.

The sip_accept_t is defined as follows:

typedef struct sip_accept_s {
sip_common_t ac_common[1]; // Common fragment info
sip_accept_t *ac_next; // Pointer to next @Acceptheader
char const *ac_type; // Pointer to type/subtype
char const *ac_subtype; // Points after first slash in type
msg_param_t const *ac_params; // List of parameters
char const *ac_q; // Value of q parameter
} sip_accept_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_accept_s
Structure for Accept header field.
Definition sip.h:400
sip_accept_s::ac_type
char const * ac_type
Pointer to type/subtype.
Definition sip.h:403
sip_accept_s::ac_q
char const * ac_q
Value of q parameter.
Definition sip.h:406
sip_accept_s::ac_params
msg_param_t const * ac_params
List of parameters.
Definition sip.h:405
sip_accept_s::ac_subtype
char const * ac_subtype
Points after first slash in type.
Definition sip.h:404
sip_accept_s::ac_common
sip_common_t ac_common[1]
Common fragment info.
Definition sip.h:401
sip_accept_s::ac_next
sip_accept_t * ac_next
Pointer to next Accept value.
Definition sip.h:402

## Function Documentation

## sip_accept_copy()

sip_accept_t * sip_accept_copy | ( | su_home_t * | home,
|  | sip_accept_t const * | hdr )

inline

Copy a list of Accept header header structures sip_accept_t.

The function sip_accept_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  accept = sip_accept_copy(home, sip->sip_accept);
  sip_accept_copy
  sip_accept_t * sip_accept_copy(su_home_t *home, sip_accept_t const *hdr))
  Copy a list of Accept header header structures sip_accept_t.
  Definition sip_protos.h:7180

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_accept_dup()

sip_accept_t * sip_accept_dup | ( | su_home_t * | home,
|  | sip_accept_t const * | hdr )

inline

Duplicate a list of Accept header header structures sip_accept_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  accept = sip_accept_dup(home, sip->sip_accept);
  sip_accept_dup
  sip_accept_t * sip_accept_dup(su_home_t *home, sip_accept_t const *hdr))
  Duplicate a list of Accept header header structures sip_accept_t.
  Definition sip_protos.h:7137

Returns
  A pointer to the newly duplicated sip_accept_t header structure, or NULL upon an error.

## sip_accept_format()

sip_accept_t * sip_accept_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Accept header from formatting result.

Make a new sip_accept_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_accept_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_accept_init()

sip_accept_t * sip_accept_init | ( | sip_accept_t | x[1] | ) |

inline

Initialize a structure sip_accept_t.

An sip_accept_t structure for Accept header can be initialized with the sip_accept_init() function/macro. For instance,

sip_accept_t sip_accept;
sip_accept_init(&sip_accept);
sip_accept_init
sip_accept_t * sip_accept_init(sip_accept_t x[1])
Initialize a structure sip_accept_t.
Definition sip_protos.h:7068

## sip_accept_make()

sip_accept_t * sip_accept_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Accept header structure sip_accept_t.

The function sip_accept_make() makes a new sip_accept_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_accept_t header structure, or NULL upon an error.

## sip_is_accept()

int sip_is_accept | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_accept_t.

Check if the header class is an instance of Accept header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header accept
  0 | (false) otherwise

## Variable Documentation

## sip_accept_class

msg_hclass_t sip_accept_class[]

extern

Header class for Accept header.

The header class sip_accept_class defines how a SIP Accept header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_accept_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.